from Plugins.Plugin import PluginDescriptor
from Components.config import config, ConfigText, ConfigSubDict, ConfigYesNo

from UpdateCheck import reload_value
from enigma import eTimer

import UpdateCheck
#import AutoUpdateCheck

VERSION = "0.5 beta"

session = None
updateTimer = None
updateTimer_conn = None

def leaveStandbyUDC():
	global session, updateTimer, updateTimer_conn
	try:
		print "=====[UpdateCheck] aus standby aufgewacht ..."
		if config.plugins.updatecheck.enable_autocheck.value != "False":
			print "=====[UpdateCheck] runUpdateCheck after %s seconds:" % config.plugins.updatecheck.updatecheck_delay.value
			updateTimer = eTimer()
			updateTimer_conn = updateTimer.timeout.connect(startUpdateCheck)
			updateTimer.start(int(config.plugins.updatecheck.updatecheck_delay.value)*1000)

	except:
		import traceback
		traceback.print_exc()

def standbyCounterChangedUDC(configElement):
	
	print "=====[UpdateCheck] gehe in standby..."
	from Screens.Standby import inStandby
	inStandby.onClose.append(leaveStandbyUDC)

def startUpdateCheck():
	global updateTimer, updateTimer_conn
	print "=====[UpdateCheck] start UpdateCheck ...."
	updateTimer_conn = None
	updateTimer = None
	if reload_value:
		reload(UpdateCheck)
	from UpdateCheck import updatecheck as checkupdate
	checkupdate(session)

def sessionstart(reason, **kwargs):
	global session, updateTimer, updateTimer_conn
	if kwargs.has_key("session") and reason == 0:
		session = kwargs["session"]
		print "=====[UpdateCheck] sessionstart....", session
		#== add to set function at restart from standby
		config.misc.standbyCounter.addNotifier(standbyCounterChangedUDC, initial_call = False)
		
		if config.plugins.updatecheck.enable_autocheck.value != "False":
			print "=====[UpdateCheck] runUpdateCheck after %s seconds:" % config.plugins.updatecheck.updatecheck_delay.value
			updateTimer = eTimer()
			updateTimer_conn = updateTimer.timeout.connect(startUpdateCheck)
			updateTimer.start(int(config.plugins.updatecheck.updatecheck_delay.value)*1000)
	else:
		print "=====[UpdateCheck] sessionstart ohne session...."
		pass

def setup(session, **kwargs):

	if reload_value:
		reload(UpdateCheck)
	from UpdateCheck import UpdateCheckSetup
	session.open(UpdateCheckSetup)

#def main(session, **kwargs):

#	if reload_value:
#		reload(UpdateCheck)
#	from UpdateCheck import UpdateScreen
#	session.open(UpdateScreen)

def Plugins(**kwargs):

	descriptors = []
	descriptors.append( PluginDescriptor(name =_("AutoUpdateCheck"), description=_("Check for Feed-Updates")+ " (" + VERSION + ")", where = PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart) )
	descriptors.append( PluginDescriptor(name =_("UpdateCheck Setup"), description=_("Check for Feed-Updates")+ " (" + VERSION + ")", where= PluginDescriptor.WHERE_PLUGINMENU, fnc = setup, needsRestart = False, icon = "UpdateCheck.png") )
	#descriptors.append( PluginDescriptor(name =_("UpdateCheck"), description=_("Check for Feed-Updates")+ " (" + VERSION + ")", where= PluginDescriptor.WHERE_EXTENSIONSMENU, fnc = main, needsRestart = False, icon = "UpdateCheck.png") )

	return descriptors
